#!/usr/local/bin/perl
# ねこけいじばん Ver.1.9.0

	use strict;
	use CGI;

# --------------------------------------------------------------------------------------------------
# CGI設定
# --------------------------------------------------------------------------------------------------

	# 管理パスワード
	my $password = "";

	# CGIファイル名
	my $cgifilename = "bbs.cgi";

	# ログファイル名
	my $logfilename = "log.dat";

	# キーワード画像のフォルダ名
	my $imgfoldername = "img";

	# 掲示板タイトル
	my $bbstitle = "ねこけいじばん";

	# ホームページURL（設定するとフッターに表示されます。）
	my $homepageurl = "";

	# 変換モード（0:ねこ語 1:わんこ語 2:うさ語 その他:変換しない）
	my $replacemode = 0;

	# スパムチェック
	my $spamcheck = 1;

	# 自動リンク
	my $autolink = 1;

	# flock関数（0:使わない 1:使う）
	my $useflock = 1;

	# 投稿文字数制限（名前）
	my $maxname = 50;

	# 投稿文字数制限（メッセージ）
	my $maxmessage = 2000;

	# 1ページの表示件数
	my $maxpagelog = 15;

	# 最大ページ数
	my $maxpage = 15;

	# 許可URL個数（スパムチェック用）
	my $maxurl = 5;

	# 管理ページの最大表示件数
	my $maxadminview = 50;



# --------------------------------------------------------------------------------------------------
# 基本HTML定義
# --------------------------------------------------------------------------------------------------
# 上部HTML
my $html_header = <<"_HTML_";
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="initial-scale=1.0">
	<link rel="stylesheet" href="css/style.css">
	<title>${bbstitle}</title>
</head>
<body>
<div class="contents">
	<header>
		<h1><a href="./">${bbstitle}</a></h1>
		<div class="subtitle">文字がねこ語に変わる不思議な掲示板です。</div>
	</header>
	<div class="main">
_HTML_

# 入力フォームHTML
my $html_form = <<"_HTML_";
		<div class="bbsform">
			<form name="bbsform" action="bbs.cgi" method="post">
				<div><input type="text" name="name" placeholder="Name" required></div>
				<div><textarea name="message" placeholder="Message" required></textarea></div>
				<div class="post"><button>Write</button></div>
			</form>
		</div>
_HTML_

# キーワード説明HTML
my $html_keyword = <<"_HTML_";
		<div class="keyword">
			<hr>
			<p>
				キーワードで画像が出ます。<br>
				<img src="${imgfoldername}/neko.png" width="12" height="12" alt="">ねこ
				<img src="${imgfoldername}/cat.png" width="12" height="12" alt="">ネコ
				<img src="${imgfoldername}/wanko.png" width="12" height="12" alt="">わんこ
				<img src="${imgfoldername}/usagi.png" width="12" height="12" alt="">ウサギ
				<img src="${imgfoldername}/nekokan.png" width="12" height="12" alt="">ネコ缶
				<img src="${imgfoldername}/kinoko.png" width="12" height="12" alt="">きのこ
				<img src="${imgfoldername}/heart.png" width="12" height="12" alt="">ハート
			</p>
			<hr>
		</div>
_HTML_

# 下部HTML
my $html_footer = <<"_HTML_";
	</div>
	<footer>
_HTML_
if ($homepageurl ne "") {
$html_footer .= <<"_HTML_";
		<p><a href="${homepageurl}">ホームページへ戻る</a></p>
_HTML_
}
$html_footer .= <<"_HTML_";
		<p>&copy; <a href="http://www.cc9.ne.jp/~pappara/">ねこけいじばん</a></p>
	</footer>
</div>
</body>
</html>
_HTML_






	# **********************************************************************************************
	# メインルーチン
	# **********************************************************************************************
	# フォームから値を取得
	my $query = new CGI;									# CGIオブジェクトを作成
	my $form_mode		= $query->param('mode');			# 操作モード
	my $form_password	= $query->param('password');		# パスワード
	my $form_id			= $query->param('id');				# 操作対象投稿ID
	my $form_name		= $query->param('name');			# 名前
	my $form_message	= $query->param('message');			# メッセージ

	# 未定義の場合の初期化
	if (!defined($form_password)) {		$form_password = "";	}
	if (!defined($form_mode)) {			$form_mode = "";		}
	if (!defined($form_id)) {			$form_id = "";			}
	if (!defined($form_name)) {			$form_name = "";		}
	if (!defined($form_message)) {		$form_message = "";		}

	# HTMLエスケープ（XSS対策）
	if ($form_password ne "") {
		$form_password =~ s/&/&amp;/g;
		$form_password =~ s/</&lt;/g;
		$form_password =~ s/>/&gt;/g;
		$form_password =~ s/"/&quot;/g;
		$form_password =~ s/'/&#39;/g;
	}
	if ($form_mode ne "") {
		$form_mode =~ s/&/&amp;/g;
		$form_mode =~ s/</&lt;/g;
		$form_mode =~ s/>/&gt;/g;
		$form_mode =~ s/"/&quot;/g;
		$form_mode =~ s/'/&#39;/g;
	}
	if ($form_id ne "") {
		$form_id =~ s/&/&amp;/g;
		$form_id =~ s/</&lt;/g;
		$form_id =~ s/>/&gt;/g;
		$form_id =~ s/"/&quot;/g;
		$form_id =~ s/'/&#39;/g;
	}

	# GET
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
		# パスワード認証ページ表示
		&ViewLogin();
	# POST以外
	} elsif ($ENV{'REQUEST_METHOD'} ne "POST") {
		&Error("不正なアクセスです。");
	}
	# 管理モード
	if ($form_mode eq "admin" || $form_mode eq "inithtml" || $form_mode eq "deletelog") {
		# パスワードが設定されていない場合
		if ($password eq "") {
			&Error("パスワードは設定されていません。");
		}
		# パスワードが一致しない場合
		if ($form_password ne $password) {
			&Error("パスワードが不正です。");
		}
		# 管理ページ表示
		if ($form_mode eq "admin") {
			# 管理ページ表示
			&ViewAdmin("");
		# HTMLの再作成
		} elsif ($form_mode eq "inithtml") {
			&InitHTML();
		# 記事削除
		} elsif ($form_mode eq "deletelog") {
			&DeleteLog();
		}
		&Error("不正なアクセスです。");
	} else {
		# 新規投稿追加
		&AddLog();
	}
	# スクリプト終了（正常終了時には0を返す）
	exit(0);



	# **********************************************************************************************
	# 新規投稿追加
	# **********************************************************************************************
	sub AddLog {
		my $str = "";										# 文字数取得用
		my $len = 0;										# 文字数
		my $double = "";									# 連続投稿防止用文字列
		my @oldlog = ();									# 過去ログ
		my @para = ();										# 一つのログの分割パラメータ
		my @newlog = ();									# 新しいログ
		my $date = "";										# 日時
		my $number = 0;										# 投稿番号
		my $log = "";										# 一行のログ
		my $i = 0;											# ループ用変数
		my $n = 0;											# ログ数カウント用
		my $result = 0;										# 結果


		# ------------------------------------------------------------------------------------------
		# 入力チェックとテキスト整形
		# ------------------------------------------------------------------------------------------
		# 名前のチェック
		if ($form_name eq "") {
			&Error("名前が入力されていません。");
		}
		$form_name =~ s/[\r\n]//g;							# 改行を削除
		$form_name = &Trim($form_name);						# 先頭末尾の空白と空行を取り除く
		# 無記名の場合
#		if ($form_name eq "") {
#			$form_name = "匿名";
#		}
		# 名前の文字数チェック
		$str = $form_name;
		utf8::decode($str);
		$len = length($str);
		if ($len > $maxname) {
			&Error("名前が長すぎます。");
		}

		# メッセージのチェック
		if ($form_message eq "") {
			&Error("メッセージが入力されていません。");
		}
		$form_message =~ s/(\r\n|\r)/\n/g;					# 改行コードを揃える
		$form_message = &Trim($form_message);				# 先頭末尾の空白と空行を取り除く
		if ($form_message eq "") {
			&Error("空白のみの投稿はできません。");
		}
		# メッセージの文字数チェック
		$str = $form_message;
		utf8::decode($str);
		$len = length($str);
		if ($len > $maxmessage) {
			&Error("メッセージが長すぎます。");
		}

		# スパムチェック
		if ($spamcheck) {
			&SpamCheck($form_message);
		}

		# ------------------------------------------------------------------------------------------
		# 文字変換
		# ------------------------------------------------------------------------------------------
		# 名前
		$form_name =~ s/&/&amp;/g;							# &を変換
		$form_name =~ s/\t/&nbsp;/g;						# タブを変換
		$form_name =~ s/</&lt;/g;							# <を変換
		$form_name =~ s/>/&gt;/g;							# >を変換
		$form_name =~ s/"/&quot;/g;							# ダブルクォーテーションを変換
		$form_name =~ s/'/&#39;/g;							# シングルクォーテーションを変換
		$form_name =~ s/ /&nbsp;/g;							# 半角スペースを変換
		# メッセージ
		$form_message =~ s/&/&amp;/g;						# &を変換
		$form_message =~ s/\t/&nbsp;/g;						# タブを変換
		$form_message =~ s/</&lt;/g;						# <を変換
		$form_message =~ s/>/&gt;/g;						# >を変換
		$form_message =~ s/\n/<br>/g;						# 改行タグ
		$form_message =~ s/"/&quot;/g;						# ダブルクォーテーションを変換
		$form_message =~ s/'/&#39;/g;						# シングルクォーテーションを変換
		$form_message =~ s/ /&nbsp;/g;						# 半角スペースを変換

		# 連続投稿防止用文字列を記憶しておく
		$double = $form_message;

		# 「ねこ語」変換
		$form_message = &ReplaceMessage($form_message);

		# 自動リンク（メッセージ中のURLやメールアドレスにリンクタグ付加）
		if ($autolink) {
			$form_message = &AutoLink($form_message);
		}

		# ------------------------------------------------------------------------------------------
		# ログファイルを読み書きモードで開く
		# ------------------------------------------------------------------------------------------
		# ログファイルがない場合
		if (!(-e $logfilename)) {
			# ログファイルを作成
			if(!open(OUT, "> ${logfilename}")) {
				&Error("ログファイルの作成に失敗しました。");
			}
			# ファイルを閉じる
			close(OUT);
		}
		# ログファイルを読み書きモードで開く
		if (!open(INOUT, "+< ${logfilename}")) {
			&Error("ログファイルの読み込みに失敗しました。");
		}
		if ($useflock) { flock(INOUT, 2); }					# 排他ロック

		# ログを変数に代入
		@oldlog = <INOUT>;
		# ファイルポインタを先頭にセット
		seek(INOUT, 0, 0);

		# 連続投稿防止用文字列と同じ場合
		if ($oldlog[0] eq ($double . "\n")) {
			# ファイルを閉じる
			close(INOUT);
			&Error("前回のメッセージと同じです。");
		}

		# 連続投稿防止用文字列の削除（配列の一番目を削除）
		shift(@oldlog);

		# ------------------------------------------------------------------------------------------
		# 一行のログデータを作成
		# ------------------------------------------------------------------------------------------
		# 日時の取得
		$date = &GetDate();

		# 投稿番号を取り出す
		@para = split(/<>/, $oldlog[0]);
		$number = $para[0] + 1;

		# 一行のログデータを作成（投稿番号<>日時<>名前<>メッセージ<>\n）
		$log = "${number}<>${date}<>${form_name}<>${form_message}<>\n";

		# ------------------------------------------------------------------------------------------
		# すべてのログデータを作成
		# ------------------------------------------------------------------------------------------
		# 配列の結合(@oldlogの先頭に$logを付け足す)
		unshift(@oldlog, $log);

		$n = 0;		# 投稿数
		for ($i = 0; $i < $#oldlog + 1; $i++) {
			# 投稿数が保存件数を超えたら終わり（保存件数を超えたログは削除していく）
			if ($n >= ($maxpage * $maxpagelog)) {
				last;
			}
			# 配列@newlogの最後に追加
			push(@newlog, $oldlog[$i]);
			# 投稿数を数える
			$n++;
		}

		# ------------------------------------------------------------------------------------------
		# ログファイル書き込み
		# ------------------------------------------------------------------------------------------
		# 書き込み
		print INOUT $double . "\n";							# 二重投稿禁止用語
		print INOUT @newlog;								# その他のログ

		# ファイルサイズを書き込んだサイズにする
		truncate(INOUT, tell(INOUT));
		# ファイルを閉じる（※flock関数のロックは自動的に解除される）
		close(INOUT);

		# ------------------------------------------------------------------------------------------
		# 閲覧用HTMLファイルの作成
		# ------------------------------------------------------------------------------------------
		$result = &CreateHTML(@newlog);
		# 1: ログファイル保存に失敗
		if ($result == 1) {
			&Error("ログファイルの保存に失敗しました。");
		# 2: HTMLファイル保存に失敗
		} elsif ($result == 2) {
			&Error("HTMLファイルの保存に失敗しました。");
		}

		# 掲示板トップページへ移動
		print "Location: ./\n\n";
		exit;
	}



	# **********************************************************************************************
	# ログ配列から閲覧用HTMLファイルの作成
	# 【引数】
	# 		@_					ログ（２行目以降）を格納した配列変数
	# 【戻り値】
	# 		0: 正常終了
	# 		1: ログファイル保存に失敗
	# 		2: HTMLファイル保存に失敗
	# **********************************************************************************************
	sub CreateHTML {
		my @logall = @_;									# すべてのログ
		my @para = ();										# 一つのログの分割パラメータ
		my $lognum = 0;										# 全ログ件数
		my $pagenum = 0;									# 総ページ数
		my $pagelink = "";									# ページネーションのHTML
		my $id = 0;											# 現在の投稿番号
		my $i = 0;											# 一時変数
		my $j = 0;											# 一時変数
		my $n = 0;											# 一時的なログ数カウント用
		my $flag_err = 0;									# エラーフラグ


		# 全ログ件数を取得
		$lognum = $#logall + 1;

		# ログがない場合
		if ($lognum <= 0) {
			# --------------------------------------------------------------------------------------
			# 「index.html」ファイルを保存
			# --------------------------------------------------------------------------------------
			# ファイルを書き込みモードで開く
			if (!open(OUT, "> index.html")) {
				# ログファイル保存に失敗
				return 1;
			}
			if ($useflock) { flock(OUT, 2); }				# 排他ロック
			# 上部HTML
			print OUT $html_header . $html_form . $html_keyword;
			# 下部HTML
			print OUT $html_footer;
			# ファイルを閉じる
			close(OUT);
			# 正常終了
			return 0;
		}

		# 全ログ件数と1ページに表示する件数から総ページ数を求める
		$pagenum = int($lognum / $maxpagelog);
		if (int(($lognum % $maxpagelog)) > 0) {
			$pagenum++;
		}

		# 総ページ数分のHTMLファイルを作成
		for ($i = 1; $i <= $pagenum; $i++) {

			# --------------------------------------------------------------------------------------
			# ページネーションのHTMLを作成
			# --------------------------------------------------------------------------------------
			# 1ページのみの場合
			if ($pagenum <= 1) {
				$pagelink = "";
			# 複数ページになる場合
			} else {
				$pagelink = "\t\t<nav class=\"pagination\">\n\t\t\t";

				# 1ページ目の場合
				if ($i == 1) {
					$pagelink .= "<span class=\"thispage\">1</span> ";
				} else {
					$pagelink .= "<a href=\"./\">1</a> ";
				}

				for ($j = 2; $j <= $pagenum; $j++) {
					# ページが同じになったらリンクしない
					if ($i == $j) {
						$pagelink .= "<span class=\"thispage\">${j}</span> ";
					} else {
						$pagelink .= "<a href=\"page${j}.html\">${j}</a> ";
					}
				}
				$pagelink .= "\n\t\t</nav>\n";
			}

			# --------------------------------------------------------------------------------------
			# HTMLファイルを保存
			# --------------------------------------------------------------------------------------
			# 1ページ目はindexページ
			if ($i == 1) {
				if (!open(OUT, "> index.html")) {
					$flag_err = 1;
					# 保存に失敗しても次のファイル保存を試す
					next;
				}
			# 2ページ以降は過去の投稿を表示するページ
			} else {
				if (!open(OUT, "> page${i}.html")) {
					$flag_err = 1;
					# 保存に失敗しても次のファイル保存を試す
					next;
				}
			}
			if ($useflock) { flock(OUT, 2); }				# 排他ロック

			# 上部HTML
			print OUT $html_header;
			if ($i == 1) {		# 1回目はindexページ
				print OUT $html_form . $pagelink;
			} else {
				print OUT $pagelink;
			}

			# --------------------------------------------------------------------------------------
			# ページに表示する件数だけ繰り返す
			# --------------------------------------------------------------------------------------
			$n = 0;			# ログ数を初期化
			for ($j = 0; $j <= $#logall; $j++) {

				# 配列の数を超えたら抜ける
				if ($id > $#logall) { last; }

				# ログ分割（投稿番号<>日時<>名前<>メッセージ<>）
				@para = split(/<>/, $logall[$id++]);

# 投稿HTMLの作成
print OUT <<"_HTML_";
		<article>
			<h3>$para[2]</h3>
			<div class="date">$para[1]</div>
			<div class="message">$para[3]</div>
		</article>
_HTML_

				# ログ数を数える
				$n++;

				# 表示スレッド数に達していたらループを抜ける
				if ($n >= $maxpagelog) { last; }
			}

			print OUT $pagelink;
			if ($i == 1) {		# 1回目はindexページ
				print OUT $html_keyword;
			}
			print OUT $html_footer;

			# ファイルを閉じる
			close(OUT);
		}

		# HTMLファイル保存に失敗している場合
		if ($flag_err != 0) {

			# HTMLファイル保存に失敗
			return 2;
		}

		# 正常終了
		return 0;
	}



	# **********************************************************************************************
	# パスワード認証ページ表示
	# **********************************************************************************************
	sub ViewLogin {
		print "Content-Type: text/html; charset=utf-8;\n\n";
		print $html_header;

print <<"_HTML_";
		<div class="login">
			<p>パスワード入力</p>
			<form name="login" action="bbs.cgi" method="post">
				<input type="password" name="password">
				<button name="mode" value="admin">Login</button>
			</form>
		</div>
_HTML_

		print $html_footer;
		exit;
	}



	# **********************************************************************************************
	# 管理ページ表示
	# **********************************************************************************************
	sub ViewAdmin {
		my $str_stat = $_[0];								# 現在の状態メッセージ
		my $html_stat = "";									# 現在の状態メッセージHTML
		my @alllog = ();									# すべてのログ
		my @para = ();										# 一つのログの分割パラメータ
		my $lognum = 0;										# ログ件数
		my $lognum_view = 0;								# 表示ログ件数
		my $i = 0;											# 一時変数




		# ------------------------------------------------------------------------------------------
		# ログファイルを読み込みモードで開く
		# ------------------------------------------------------------------------------------------
		# ログファイルがある場合
		if (-e $logfilename) {
			if (!open(IN, "< " . $logfilename)) {
				&Error("ログファイルの読み込みに失敗しました。");
			}
			# ログを変数に代入
			@alllog = <IN>;
			# ログの一行目を削除（配列の先頭を削除）
			shift(@alllog);
			# ファイルを閉じる
			close(IN);
		}

		# ログ件数を取得
		$lognum = $#alllog + 1;

		# HTML表示開始
		print "Content-Type: text/html; charset=utf-8;\n\n";

		# 上部HTML
		print $html_header;

		# ページ内表示件数を設定
		if ($lognum <= $maxadminview) {
			$lognum_view = $lognum;
		} else {
			$lognum_view = $maxadminview;
		}


		# 状態メッセージがある場合
		if ($str_stat ne "") {
$html_stat = <<"_HTML_";
					<td>
						<div class="stat">${str_stat}</div>
					</td>
_HTML_
		}

# テーブル先頭HTML
print <<"_HTML_";
		<section class="messagelist">
			<div class="menu">
				<table>
					<tr>
						<td>
							<form name="menubutton" action="./" method="get">
								<button title="掲示板トップページへ移動します。">戻る</button>
							</form>
						</td>
						<td>
							<form name="menubutton" action="${cgifilename}" method="post">
								<input type="hidden" name="password" value="${password}">
								<button name="mode" value="admin" title="このページを更新します。">管理ページを更新</button>
							</form>
						</td>
						<td>
							<form name="menubutton" action="${cgifilename}" method="post">
								<input type="hidden" name="password" value="${password}">
								<button name="mode" value="inithtml" title="「index.html」など閲覧ページのHTMLファイルをログから再作成します。">HTMLの再作成</button>
							</form>
						</td>
${html_stat}				</tr>
				</table>
			</div>
			<div class="messagelist-number">全${lognum}件 （中${lognum_view}件表示）</div>
			<table class="maintable">
				<colgroup>
					<col span="1" class="number">
					<col span="1" class="date">
					<col span="1" class="name">
					<col span="1" class="message">
					<col span="1" class="operation">
				</colgroup>
				<thead>
					<tr>
						<th scope="col">No.</th>
						<th scope="col">日時</th>
						<th scope="col">名前</th>
						<th scope="col">メッセージ</th>
						<th scope="col">削除</th>
					</tr>
				</thead>
				<tbody>
_HTML_

			# --------------------------------------------------------------------------------------
			# ページに表示する件数だけ繰り返す
			# --------------------------------------------------------------------------------------
			for ($i = 0; $i <= $#alllog; $i++) {
				# 表示件数を超えたログは表示しない
				if ($i >= $maxadminview) {
					last;
				}
				# ログ分割（投稿番号<>日時<>名前<>メッセージ<>）
				@para = split(/<>/, $alllog[$i]);
# 投稿内容HTML
print <<"_HTML_";
					<tr>
						<td>$para[0]</td>
						<td>$para[1]</td>
						<td>$para[2]</td>
						<td>$para[3]</td>
						<td>
							<form name="delete" action="${cgifilename}" method="post">
								<input type="hidden" name="password" value="${password}">
								<input type="hidden" name="id" value="$para[0]">
								<button type="submit" name="mode" value="deletelog">削除</button>
							</form>
						</td>
					</tr>
_HTML_
			}

# テーブル末尾HTML
print <<"_HTML_";
				</tbody>
			</table>
		</section>
_HTML_

		# 下部HTML
		print $html_footer;
		exit;
	}



	# **********************************************************************************************
	# HTMLの再作成
	# **********************************************************************************************
	sub InitHTML {
		my @newlog = ();									# ログ全体
		my $result = 0;										# 結果


		# ログファイルがある場合
		if (-e $logfilename) {
			# ログファイルを読み込みモードで開く
			if (!open(IN, "< ${logfilename}")) {
				&Error("ログファイルの読み込みに失敗しました。");
			}
			if ($useflock) { flock(IN, 2); }				# 排他ロック
			# ログを変数に代入
			@newlog = <IN>;
			# ログの一行目を削除（配列の先頭を削除）
			shift(@newlog);
			# ファイルを閉じる
			close(IN);
		}

		# ------------------------------------------------------------------------------------------
		# 閲覧用HTMLファイルの作成
		# ------------------------------------------------------------------------------------------
		$result = &CreateHTML(@newlog);
		# 1: ログファイル保存に失敗
		if ($result == 1) {
			&Error("ログファイルの保存に失敗しました。");
		# 2: HTMLファイル保存に失敗
		} elsif ($result == 2) {
			&Error("HTMLファイルの保存に失敗しました。");
		}

		# 管理ページ表示
		&ViewAdmin("作成が完了しました。");
	}



	# **********************************************************************************************
	# 記事削除
	# **********************************************************************************************
	sub DeleteLog {
		my $i = 0;											# 一時変数
		my @oldlog = ();									# 過去ログ
		my @para = ();										# 一つのログの分割パラメータ
		my @newlog = ();									# 新しいログ
		my $double = "";									# 連続投稿防止用文字列
		my $del_cnt = 0;									# 実際に削除した件数
		my $result = 0;										# 結果


		# 削除番号のチェック
		if ((!($form_id =~ /^([0-9]+)/)) || ($form_id < 0)) {
			&Error("削除対象が不正です。");
		}

		# ------------------------------------------------------------------------------------------
		# ログファイルを読み書きモードで開く
		# ------------------------------------------------------------------------------------------
		# ログファイルがない場合
		if (!(-e $logfilename)) {
			# ログファイルを作成
			if(!open(OUT, "> ${logfilename}")) {
				&Error("ログファイルの作成に失敗しました。");
			}
			# ファイルを閉じる
			close(OUT);
			&Error("ログが存在しなかったためログファイルを作成しました。");
		}
		# ログファイルを読み書きモードで開く
		if (!open(INOUT, "+< ${logfilename}")) {
			&Error("ログファイルの読み込みに失敗しました。");
		}
		if ($useflock) { flock(INOUT, 2); }					# 排他ロック
		# ログを変数に代入
		@oldlog = <INOUT>;
		# ファイルポインタを先頭にセット
		seek(INOUT, 0, 0);

		# 連続投稿防止用文字列を記憶しておく
		$double = shift(@oldlog);

		# ------------------------------------------------------------------------------------------
		# 削除対象記事を除いたログ配列を作成
		# ------------------------------------------------------------------------------------------
		for ($i = 0; $i <= $#oldlog; $i++) {
			# ログの分割
			@para = split(/<>/, $oldlog[$i]);
			# 削除件数が0の場合、かつ、削除対象の投稿番号の場合
			if ($del_cnt == 0 && $para[0] eq $form_id) {
				# 削除件数をカウント
				$del_cnt++;
			} else {
				# 削除しない記事はログ配列末尾に追加
				push(@newlog, $oldlog[$i]);
			}
		}
		# 削除件数が0件の場合
		if ($del_cnt == 0) {
			&Error("削除記事 No.${form_id} が見つかりません。");
		}

		# ------------------------------------------------------------------------------------------
		# ログファイル書き込み
		# ------------------------------------------------------------------------------------------
		# 書き込み
		print INOUT $double;								# 二重投稿禁止用語
		print INOUT @newlog;								# その他のログ

		# ファイルサイズを書き込んだサイズにする
		truncate(INOUT, tell(INOUT));
		# ファイルを閉じる
		close(INOUT);

		# ------------------------------------------------------------------------------------------
		# 閲覧用HTMLファイルの作成
		# ------------------------------------------------------------------------------------------
		$result = &CreateHTML(@newlog);
		# 1: ログファイル保存に失敗
		if ($result == 1) {
			&Error("ログファイルの保存に失敗しました。");
		# 2: HTMLファイル保存に失敗
		} elsif ($result == 2) {
			&Error("HTMLファイルの保存に失敗しました。");
		}

		# 管理ページ表示
		&ViewAdmin("No.${form_id}を削除しました。");
	}



	# **********************************************************************************************
	# 「ねこ語」変換
	# **********************************************************************************************
	sub ReplaceMessage {
		my $message = $_[0];								# 元のメッセージ
		my $len = length($message);							# 文字列の長さ（文字単位）
		my $i = 0;											# 文字インデックス（文字単位）
		my $new_message = "";								# 変換後の文字列
		my $c = "";											# 一文字
		my $c_old = "";										# 直前の一文字
		my $t = 0;											# 乱数用
		my $type = 0;										# 文字タイプ（0:ひらがな 1:カタカナ 2:漢字 3:その他）
		my $type_old = -1;									# 直前の文字の文字タイプ
		my $type_cnt = 0;									# 文字タイプのカウント（同じ文字タイプが連続しているかどうか）


		# 乱数初期化（※rand関数で返される乱数のシードをセットする）
		srand(time);

		# キーワードの画像化
		$message =~ s/ねこ/<img src=\"${imgfoldername}\/neko.png\" width=\"12\" height=\"12\" alt=\"\">/g;
		$message =~ s/わんこ/<img src=\"${imgfoldername}\/wanko.png\" width=\"12\" height=\"12\" alt=\"\">/g;
		$message =~ s/ウサギ/<img src=\"${imgfoldername}\/usagi.png\" width=\"12\" height=\"12\" alt=\"\">/g;
		$message =~ s/ネコ缶/<img src=\"${imgfoldername}\/nekokan.png\" width=\"12\" height=\"12\" alt=\"\">/g;
		$message =~ s/ネコ/<img src=\"${imgfoldername}\/cat.png\" width=\"12\" height=\"12\" alt=\"\">/g;
		$message =~ s/きのこ/<img src=\"${imgfoldername}\/kinoko.png\" width=\"12\" height=\"12\" alt=\"\">/g;
		$message =~ s/ハート/<img src=\"${imgfoldername}\/heart.png\" width=\"12\" height=\"12\" alt=\"\">/g;

		# 「ねこ語」
		if ($replacemode == 0) {
			$message =~ s/に/にぃ/g;
			$message =~ s/な/にゃ/g;
			$message =~ s/の/にょ/g;
			$message =~ s/♪/にゃん♪/g;
			$message =~ s/★/ミャ★/g;
			$message =~ s/!/ニャ!/g;
			$message =~ s/\?/みゃ\?/g;

			# --------------------------------------------------------------------------------------
			# 語尾の「にゃ。にゃん。にゃ～。」をランダムで変換
			# --------------------------------------------------------------------------------------
			# UTF8のバイトコードを文字列として扱う
			utf8::decode($message);
			# 文字列の長さ（文字単位）
			$len = length($message);
			# 一文字ずつ
			for ($i = 0; $i < $len; $i++) {
				$c = substr($message, $i, 1);
				utf8::encode($c);
				if ($c eq "。") {
					if (($c_old eq "さ") || ($c_old eq "ね") || ($c_old eq "よ") || ($c_old eq "わ")) {
						$new_message .= "。";
					} else {
						# ランダムで３種類のうちのどれか
						$t = int(rand(3));
						if ($t == 0) {			$new_message .= "にゃ。";
						} elsif ($t == 1) {		$new_message .= "にゃん。";
						} else {				$new_message .= "にゃ～。";
						}
					}
				} elsif ($c eq "？") {
					$t = int(rand(5));
					if ($t == 0) {			$new_message .= "みゃ？";
					} elsif ($t == 1) {		$new_message .= "みゃ～？";
					} elsif ($t == 2) {		$new_message .= "にゃ～？";
					} elsif ($t == 3) {		$new_message .= "にゃん？";
					} else {				$new_message .= "にゃ？";
					}
				} elsif ($c eq "！") {
					$t = int(rand(4));
					if ($t == 0) {			$new_message .= "ニャ！";
					} elsif ($t == 1) {		$new_message .= "にゃ！";
					} elsif ($t == 2) {		$new_message .= "ニャ～！";
					} else {				$new_message .= "にゃん！";
					}
				} else {
					$new_message .= $c;
					$c_old = $c;
				}
			}
			# 文字列をUTF8のバイトコードとして扱う
			utf8::encode($message);

		# 「わんこ語」
		} elsif ($replacemode == 1) {
			$message =~ s/♪/ワン♪/g;
			$message =~ s/★/ワン★/g;
			$message =~ s/!/ワン!/g;
			$message =~ s/\?/わん\?/g;

			# --------------------------------------------------------------------------------------
			# 語尾や単語の最後に「わん」を付けたりする
			# --------------------------------------------------------------------------------------
			# UTF8のバイトコードを文字列として扱う
			utf8::decode($message);
			# 文字列の長さ（文字単位）
			$len = length($message);
			# 一文字ずつ
			for ($i = 0; $i < $len; $i++) {
				$c = substr($message, $i, 1);
				utf8::encode($c);
				if ($c eq "。") {
					$t = int(rand(8));
					if ($t == 0) {		$new_message .= "わん。";
					} elsif($t == 1) {	$new_message .= "ワン。";
					} elsif($t == 2) {	$new_message .= "だわん。";
					} elsif($t == 3) {	$new_message .= "だワン。";
					} elsif($t == 4) {	$new_message .= "わん！";
					} elsif($t == 5) {	$new_message .= "ワン！";
					} elsif($t == 6) {	$new_message .= "わんっ！";
					} else {			$new_message .= "ワンッ！";
					}
					$type_old = 3;
				} elsif ($c eq "？") {
					$t = int(rand(2));
					if ($t == 0) {		$new_message .= "わん？";
					} else {			$new_message .= "ワン？";
					}
					$type_old = 3;
				} elsif ($c eq "！") {
					$t = int(rand(6));
					if ($t == 0) {		$new_message .= "わん！";
					} elsif($t == 1) {	$new_message .= "ワン！";
					} elsif($t == 2) {	$new_message .= "だわん！";
					} elsif($t == 3) {	$new_message .= "だワン！";
					} elsif($t == 4) {	$new_message .= "わんっ！";
					} else {			$new_message .= "ワンッ！";
					}
					$type_old = 3;
				} else {
					$c_old = $c;
					# 文字タイプの判定
					utf8::decode($c);
					if ($c =~ /\p{InHiragana}/) {						$type = 0;		# ひらがな
					} elsif ($c =~ /\p{InKatakana}/) {					$type = 1;		# カタカナ
					} elsif ($c =~ /\p{InCJKunifiedideographs}/) {		$type = 2;		# 漢字
					} else {											$type = 3;		# その他
					}
					# 直前の文字と文字タイプが異なる場合
					if ($type != $type_old) {
						# 2文字以上の文字タイプの連なり、かつ、カタカナ・漢字の場合
						if ($type_cnt >= 2 && ($type_old == 1 || $type_old == 2)) {
							# ときどき単語に「ワン」を付ける
							$t = int(rand(5));
							if ($t == 0) {
								$new_message .= "ワン";
							}
						}
						$type_cnt = 0;
					}
					$new_message .= $c_old;
					$type_cnt++;
					$type_old = $type;
				}
			}

		# 「うさ語」
		} elsif ($replacemode == 2) {
			$message =~ s/♪/ピョン♪/g;
			$message =~ s/★/ピョン★/g;
			$message =~ s/!/ピョン!/g;
			$message =~ s/\?/ぴょ\?/g;

			# --------------------------------------------------------------------------------------
			# 語尾や単語の最後に「ぴょん」を付けたりする
			# --------------------------------------------------------------------------------------
			# UTF8のバイトコードを文字列として扱う
			utf8::decode($message);
			# 文字列の長さ（文字単位）
			$len = length($message);
			# 一文字ずつ
			for ($i = 0; $i < $len; $i++) {
				$c = substr($message, $i, 1);
				utf8::encode($c);
				if ($c eq "。") {
					$t = int(rand(7));
					if ($t == 0) {		$new_message .= "ぴょん。";
					} elsif($t == 1) {	$new_message .= "ぴょん！";
					} elsif($t == 2) {	$new_message .= "ぴょんっ！";
					} elsif($t == 3) {	$new_message .= "だぴょん！";
					} elsif($t == 4) {	$new_message .= "ピョン。";
					} elsif($t == 5) {	$new_message .= "ピョン！";
					} else {			$new_message .= "ピョンッ！";
					}
					$type_old = 3;
				} elsif ($c eq "！") {
					$t = int(rand(5));
					if ($t == 0) {		$new_message .= "ぴょん！";
					} elsif($t == 1) {	$new_message .= "ぴょんっ！";
					} elsif($t == 2) {	$new_message .= "だぴょん！";
					} elsif($t == 3) {	$new_message .= "ピョン！";
					} else {			$new_message .= "ピョンッ！";
					}
					$type_old = 3;
				} elsif ($c eq "？") {
					$t = int(rand(2));
					if ($t == 0) {		$new_message .= "ぴょん？";
					} else {			$new_message .= "ピョン？";
					}
					$type_old = 3;
				} else {
					$c_old = $c;
					# 文字タイプの判定
					utf8::decode($c);
					if ($c =~ /\p{InHiragana}/) {						$type = 0;		# ひらがな
					} elsif ($c =~ /\p{InKatakana}/) {					$type = 1;		# カタカナ
					} elsif ($c =~ /\p{InCJKunifiedideographs}/) {		$type = 2;		# 漢字
					} else {											$type = 3;		# その他
					}
					# 直前の文字と文字タイプが異なる場合
					if ($type != $type_old) {
						# 2文字以上の文字タイプの連なり、かつ、カタカナ・漢字の場合
						if ($type_cnt >= 2 && ($type_old == 1 || $type_old == 2)) {
							# ときどき単語に「ぴょん」を付ける
							$t = int(rand(5));
							if ($t == 0) {
								$new_message .= "ぴょん";
							}
						}
						$type_cnt = 0;
					}
					$new_message .= $c_old;
					$type_cnt++;
					$type_old = $type;
				}
			}
			# 文字列をUTF8のバイトコードとして扱う
			utf8::encode($message);
		}

		# 変換した文字列を返す
		return $new_message;
	}



	# **********************************************************************************************
	# URL・メールアドレスのリンクタグ付加
	# **********************************************************************************************
	sub AutoLink {
		my $message = $_[0];								# 処理対象文字列

		# URL
		$message =~ s/(https?\:\/\/[\w\.~\-\/\?&=;:%\+@]+)/<a class="linkurl" href="$1">$1<\/a>/g;
		# Mail
		$message =~ s/([\w._\-]+@[\w._\-]+)/<a class="linkmail" href="mailto:$1">$1<\/a>/g;
		return $message;
	}



	# **********************************************************************************************
	# 先頭末尾の空白と空行を取り除く
	# **********************************************************************************************
	sub Trim {
		my $str = $_[0];									# 処理対象文字列

		$str =~ s/^\n*//;									# 先頭の改行
		$str =~ s/\n*$//;									# 末尾の改行
		$str =~ s/^\s*(.*?)\s*$/$1/;						# 先頭末尾空白
		return $str;
	}



	# **********************************************************************************************
	# 日時の取得
	# **********************************************************************************************
	sub GetDate {
		my ($sec, $min, $hour, $day, $mon, $year) = localtime(time);
		my $str = sprintf("%04d/%02d/%02d %02d:%02d", $year + 1900, $mon +1, $day, $hour, $min);
		return $str;
	}



	# **********************************************************************************************
	# スパムチェック
	# **********************************************************************************************
	sub SpamCheck {
		my $message = $_[0];								# 処理対象文字列
		my @cnt;											# URLカウント用


		# メッセージにリンクタグの「href=」が含まれている場合
		if ($message =~ /href\s*=/i) {
			&Error("リンクタグを含む投稿はできません。");
		}

		# 半角英数記号のみの場合（テキストの最初から最後までASCII文字の場合）
		if ($message =~ /^[\x00-\x7F]+$/) {
			&Error("英数字のみの投稿はできません。");
		}

		# URLが多数含まれている場合
		@cnt = ($message =~ /(http:\/\/)/g);
		if ($#cnt + 1 > $maxurl) {
			&Error("メッセージ内のURLが多すぎます。");
		}

		# 禁止ワード
#		my @bad_word = ("ワード1", "ワード2", "ワード3", );
#		foreach my $word (@bad_word) {
#			if ($message =~ /$word/i) {
#				&Error("禁止ワード「${word}」が含まれています。");
#			}
#		}
	}



	# **********************************************************************************************
	# エラーページ作成
	# **********************************************************************************************
	sub Error {
		print "Content-Type: text/html; charset=utf-8;\n\n";
		print $html_header;

print <<"_HTML_";
		<div class="errormessage">
			<div>
				<span class="err">@_</span><br>
				<span class="othermessage">ブラウザの「戻る」よりお戻りください。</span>
			</div>
		</div>

_HTML_

		print $html_footer;
		exit;
	}



__END__
